SystemOrganization addCategory: #'Path-Harvester'!
SystemOrganization addCategory: #'Path-Harvester-Types'!
SystemOrganization addCategory: #'Path-Harvester-ValueRanges'!

!InstructionStream class methodsFor: '*Path-Harvester' stamp: 'mp 5/27/2010 16:35'!
specialConstants

	^ SpecialConstants! !

Object subclass: #SBucket
	instanceVariableNames: 'arguments returns members creationDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester'!

!SBucket methodsFor: 'comparing' stamp: 'mp 6/6/2013 15:58:42.555'!
= another

	^ another class = self class and: [
		self arguments = another arguments and: [
			self members = another members and: [
				self returns = another returns]]]! !

!SBucket methodsFor: 'accessing' stamp: 'mp 5/7/2013 17:43:20.143'!
arguments
	"Answer the value of arguments"

	^ arguments! !

!SBucket methodsFor: 'accessing' stamp: 'mp 5/7/2013 17:43:20.16'!
arguments: anObject
	"Set the value of arguments"

	arguments := anObject! !

!SBucket methodsFor: 'public API' stamp: 'mp 5/8/2013 14:22:31.224'!
argumentsFor: aMethod

	^ self arguments
		at: aMethod methodReference
		ifAbsentPut: [Array new: aMethod numArgs]! !

!SBucket methodsFor: 'accessing' stamp: 'mp 6/6/2013 11:52:47.62'!
creationDate

	^ creationDate! !

!SBucket methodsFor: 'accessing' stamp: 'mp 6/6/2013 11:52:47.628'!
creationDate: anObject

	creationDate := anObject! !

!SBucket methodsFor: 'comparing' stamp: 'mp 6/6/2013 16:03:08.404'!
hash
	
	^ ((super hash bitXor: self arguments hash) 
		bitXor: self members hash) 
			bitXor: self returns hash! !

!SBucket methodsFor: 'initialize-release' stamp: 'mp 6/6/2013 11:53:00.466'!
initialize
	self creationDate: DateAndTime now.
	self reset.! !

!SBucket methodsFor: 'accessing' stamp: 'mp 5/7/2013 17:11:35.638'!
members
	"Answer the value of members"

	^ members! !

!SBucket methodsFor: 'accessing' stamp: 'mp 5/7/2013 17:11:35.654'!
members: anObject
	"Set the value of members"

	members := anObject! !

!SBucket methodsFor: 'public API' stamp: 'mp 5/8/2013 14:22:22.353'!
membersFor: aClass
	
	^ self members
		at: aClass
		ifAbsentPut: [Array new: aClass allInstVarNames size]! !

!SBucket methodsFor: 'harvesting' stamp: 'mp 5/7/2013 17:41:41.12'!
noteArgument: anObject index: aNumber in: aMethod
	"Will be called from harvester"
	self subclassResponsibility.! !

!SBucket methodsFor: 'harvesting' stamp: 'mp 5/7/2013 17:40:35.002'!
noteMember: anObject for: aNumber in: aClass
	"Will be called from harvester"
	self subclassResponsibility.! !

!SBucket methodsFor: 'harvesting' stamp: 'mp 5/7/2013 17:40:50.518'!
noteReturn: anObject in: aMethod
	"Will be called from harvester"
	self subclassResponsibility.! !

!SBucket methodsFor: 'initialize-release' stamp: 'mp 5/7/2013 17:38:20.841'!
postProcessing
	"This method is called from the inductive analysis tracer"! !

!SBucket methodsFor: 'initialize-release' stamp: 'mp 5/7/2013 17:44:57.423'!
reset
	self 
		arguments: Dictionary new;
		returns: Dictionary new;
		members: Dictionary new.
! !

!SBucket methodsFor: 'public API' stamp: 'mp 5/7/2013 17:27:55.911'!
returnFor: aMethod

	^ self returns 
		at: aMethod methodReference
		ifAbsent: [nil]! !

!SBucket methodsFor: 'accessing' stamp: 'mp 5/7/2013 17:11:35.607'!
returns
	"Answer the value of returns"

	^ returns! !

!SBucket methodsFor: 'accessing' stamp: 'mp 5/7/2013 17:11:35.623'!
returns: anObject
	"Set the value of returns"

	returns := anObject! !

SBucket subclass: #STypeBucket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-Types'!

!STypeBucket commentStamp: 'mha 3/19/2010 10:01' prior: 0!
The methodTypeMaps dictionary maps CompiledMethods to Arrays.
The array indices indicate pc values and contain references to classes,
which denote the type lying on the top of the stack BEFORE the bytecode denoted by the index is executed.
A value of nil indicates that there was either no type recorded, or that the bytecode index is none that will ever be executed
(e.g., a parameter to a bytecode instruction).!

STypeBucket subclass: #SMonoTypeBucket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-Types'!

!SMonoTypeBucket commentStamp: 'mha 3/19/2010 10:01' prior: 0!
The methodTypeMaps dictionary maps CompiledMethods to Arrays.
The array indices indicate pc values and contain references to classes,
which denote the type lying on the top of the stack BEFORE the bytecode denoted by the index is executed.
A value of nil indicates that there was either no type recorded, or that the bytecode index is none that will ever be executed
(e.g., a parameter to a bytecode instruction).!

!SMonoTypeBucket methodsFor: 'collecting types' stamp: 'mp 5/8/2013 14:32:06.9'!
containerTypeFrom: aContainer
	| container |
	container := SContainerType new. 
	container typeOfContainer: aContainer class.
	aContainer isVariableBinding
		ifTrue: [ "Association"
			container typeOfKeys: (self getTypeFromObject: aContainer key).			
			container typeOfElements: (self getTypeFromObject: aContainer value).
			^ container].
	aContainer ifNotEmpty:[
		aContainer do: [:each | container typeOfElements: 
					(self leastCommonSupertypeOf: container typeOfElements 
										and: (self getTypeFromObject: each))].
		aContainer isDictionary 
			ifTrue: [aContainer keys do: [:each | container typeOfKeys: 
					(self leastCommonSupertypeOf: container typeOfKeys 
										and: (self getTypeFromObject: each))]]].
	^ container
! !

!SMonoTypeBucket methodsFor: 'monticello conversion' stamp: 'mp 5/7/2013 18:25:07.797'!
convertToSymbols
	| symbolBucket map |
	symbolBucket := self class new.
	map := symbolBucket instVarNamed: 'arguments'.
	self arguments keysAndValuesDo: [:key :value | 
		map at: (self methodToAssoc: key) put: (self typesToSymbols: value)].
	map := symbolBucket instVarNamed: 'returns'.
	self returns keysAndValuesDo: [:key :value | 
		map at: (self methodToAssoc: key) put: (self typeToSymbol: value)].
	map := symbolBucket instVarNamed: 'members'.
	self members keysAndValuesDo: [:key :value | 
		map at: (self typeToSymbol: key) put: (self typesToSymbols: value)].
	^ symbolBucket! !

!SMonoTypeBucket methodsFor: 'monticello conversion' stamp: 'mp 5/7/2013 18:25:43.565'!
convertToTypes
	| typeBucket map |
	typeBucket := self class new.
	map := typeBucket instVarNamed: 'arguments'.
	self arguments keysAndValuesDo: [:key :value | 
		[map at: (self assocToMethod: key) put: (self symbolsToTypes: value)]
			on: Exception do: ["take next element"]].
	map := typeBucket instVarNamed: 'returns'.
	self returns keysAndValuesDo: [:key :value | 
		[map at: (self assocToMethod: key) put: (self symbolToType: value)]
			on: Exception do: ["take next element"]].
	map := typeBucket instVarNamed: 'members'.
	self members keysAndValuesDo: [:key :value | 
		[map at: (self symbolToType: key) put: (self symbolsToTypes: value)]
			on: Exception do: ["take next element"]].
	^ typeBucket! !

!SMonoTypeBucket methodsFor: 'testing' stamp: 'mp 5/8/2013 14:53:55.279'!
includesMembersFor: aClass
	^ members includesKey: aClass! !

!SMonoTypeBucket methodsFor: 'collecting types' stamp: 'mp 5/3/2011 15:14:53.578'!
leastCommonSuperContainerTypeOf: type1 and: type2
	(type1 isBehavior not and: [type2 isBehavior])
		ifTrue: [^ (type1 typeOfContainer withAllSuperclasses 
					intersection: type2 withAllSuperclasses) first].
	(type1 isBehavior and: [type2 isBehavior not])
		ifTrue: [^ (type1 withAllSuperclasses 
					intersection: type2 typeOfContainer withAllSuperclasses) first].

	"Both containers must be merged"
	type1 = type2 ifTrue: [^ type1].
	type1 typeOfContainer: (self leastCommonSupertypeOf: type1 typeOfContainer 
										and: type2 typeOfContainer).
	type1 typeOfElements: (self leastCommonSupertypeOf: type1 typeOfElements 										and: type2 typeOfElements).
	type1 typeOfKeys: (self leastCommonSupertypeOf: type1 typeOfKeys 										and: type2 typeOfKeys).
	^ type1! !

!SMonoTypeBucket methodsFor: 'collecting types' stamp: 'mp 5/3/2011 13:37:59.31'!
leastCommonSupertypeOf: type1 and: type2
	"nil is not regarded a proper type"
	type1 ifNil: [ ^ type2 = nil class ifTrue: [ nil ] ifFalse: [ type2 ] ].
	type2 ifNil: [ ^ type1 = nil class ifTrue: [ nil ] ifFalse: [ type1 ] ].
	type1 = nil class ifTrue: [ ^ type2 ].
	type2 = nil class ifTrue: [ ^ type1 ].
	
	"Container types require a special treatment"
	(type1 isBehavior not or: [type2 isBehavior not])
		ifTrue: [^ self leastCommonSuperContainerTypeOf: type1 and: type2].	
	
	"Simple cases with direct relations."
	type1 = type2 ifTrue: [ ^ type1 ].
	(type1 inheritsFrom: type2) ifTrue: [ ^ type2 ].
	(type2 inheritsFrom: type1) ifTrue: [ ^ type1 ].
	
	"All the simple cases have been dealt with; now type1 and type2 are on different
	branches of the inheritance tree."
	^ (type1 allSuperclasses intersection: type2 allSuperclasses) first! !

!SMonoTypeBucket methodsFor: 'harvesting' stamp: 'mp 5/8/2013 11:41:36.964'!
noteArgument: anObject index: aNumber in: aMethod
	|  tmpMap |
	tmpMap := self argumentsFor: aMethod.
	tmpMap size > 0 ifTrue: [
		tmpMap
			at: aNumber
			put: (self leastCommonSupertypeOf: (tmpMap at: aNumber) 
						and: (self getTypeFromObject: anObject 
								existing: (tmpMap at: aNumber))) ]! !

!SMonoTypeBucket methodsFor: 'harvesting' stamp: 'mp 5/8/2013 11:39:32.574'!
noteMember: anObject for: anIndex in: aClass
	| mtMap |
	mtMap := self membersFor: aClass.
	mtMap
		at: anIndex
		put: (self leastCommonSupertypeOf: (self getTypeFromObject: anObject 
												existing: (mtMap at: anIndex)) 
					and: (mtMap at: anIndex))! !

!SMonoTypeBucket methodsFor: 'harvesting' stamp: 'mp 5/8/2013 11:40:31.918'!
noteReturn: anObject in: aMethod
	| returnType |
	returnType := self returnFor: aMethod.
	returnType 
		ifNil: [self returns
				at: aMethod methodReference
				put: (self getTypeFromObject: anObject)]
		ifNotNil: [self returns 
					at: aMethod methodReference
					put: (self leastCommonSupertypeOf: returnType 
								and: (self getTypeFromObject: anObject 
										existing: returnType))].! !

STypeBucket subclass: #SPolyTypeBucket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-Types'!

!SPolyTypeBucket methodsFor: 'accessing' stamp: 'mp 5/8/2013 11:48:16.144'!
argumentsFor: aMethod
	^ self arguments
		at: aMethod methodReference
		ifAbsentPut: [ self arrayOfSetsSized: aMethod numTemps ]! !

!SPolyTypeBucket methodsFor: 'accessing' stamp: 'mp 5/8/2013 11:20:59.71'!
arrayOfSetsSized: aNumber
	| array |
	array := Array new: aNumber.
	1 to: aNumber do: [:each | array at: each put: Set new].
	^ array! !

!SPolyTypeBucket methodsFor: 'collecting types' stamp: 'mp 5/2/2013 14:13:56.851'!
containerTypeFrom: aContainer
	| container |
	container := SContainerType forPoly: aContainer class.
	aContainer isVariableBinding
		ifTrue: [ "Association"
			container typeOfKeys add: (self getTypeFromObject: aContainer key).			
			container typeOfElements add: (self getTypeFromObject: aContainer value).
			^ container].
	aContainer ifNotEmpty:[
		aContainer do: [:each | container typeOfElements 
									add: (self getTypeFromObject: each)].
		aContainer isDictionary 
			ifTrue: [aContainer keys do: [:each | container typeOfKeys 
													add: (self getTypeFromObject: each)]]].
	^ container
! !

!SPolyTypeBucket methodsFor: 'collecting types' stamp: 'mp 5/3/2011 10:50:15.738'!
find: aContainer in: aSet

	^ aSet detect: [:each | each isBehavior not 
								and: [each typeOfContainer = 
										aContainer typeOfContainer]] 
			ifNone: [nil].! !

!SPolyTypeBucket methodsFor: 'accessing' stamp: 'mp 5/8/2013 11:44:25.223'!
membersFor: aClass
	^ self members
		at: aClass
		ifAbsentPut: [ self arrayOfSetsSized: aClass allInstVarNames size ]! !

!SPolyTypeBucket methodsFor: 'collecting types' stamp: 'mp 5/3/2011 13:13:53.31'!
merge: aContainer and: aType into: aSet
	aContainer
		ifNil: [aSet add: aType]
		ifNotNil: ["merge container types"
			aContainer typeOfElements: 
				aContainer typeOfElements, aType typeOfElements.
			aContainer typeOfKeys: 
				aContainer typeOfKeys, aType typeOfKeys]! !

!SPolyTypeBucket methodsFor: 'harvesting' stamp: 'mp 5/8/2013 14:38:58.96'!
noteArgument: anObject index: aNumber in: aMethod
	self storeTypeOf: anObject intoSet: ((self argumentsFor: aMethod) at: aNumber).! !

!SPolyTypeBucket methodsFor: 'harvesting' stamp: 'mp 5/8/2013 14:45:26.114'!
noteMember: anObject for: aNumber in: aClass
	self storeTypeOf: anObject intoSet: ((self membersFor: aClass) at: aNumber).! !

!SPolyTypeBucket methodsFor: 'harvesting' stamp: 'mp 5/8/2013 11:46:36.546'!
noteReturn: anObject in: aMethod
	self storeTypeOf: anObject intoSet: (self returnFor: aMethod).! !

!SPolyTypeBucket methodsFor: 'accessing' stamp: 'mp 5/8/2013 11:46:13.9'!
returnFor: aMethod

	^ self returns
		at: aMethod methodReference
		ifAbsentPut: [Set new]! !

!SPolyTypeBucket methodsFor: 'collecting types' stamp: 'mp 5/3/2011 11:16:21.358'!
storeTypeOf: anObject intoSet: aSet
	| type container |
	anObject class = UndefinedObject
		ifFalse: [type := (self getTypeFromObject: anObject).
				type isBehavior ifTrue: [^ aSet add: type].
				container := self find: type in: aSet.	
				self merge: container and: type into: aSet]! !

!STypeBucket methodsFor: 'monticello conversion' stamp: 'tfel 7/8/2011 11:48:15.331'!
assocToMethod: anAssocOrBlockDescriptor
	| blockDescriptor |
	anAssocOrBlockDescriptor class == Association
		ifTrue: [^ ((self symbolToType: anAssocOrBlockDescriptor key) >> 
					anAssocOrBlockDescriptor value) methodReference]
		ifFalse: [
			blockDescriptor := anAssocOrBlockDescriptor deepCopy.
			blockDescriptor embeddingMethod: 
				(self assocToMethod: blockDescriptor embeddingMethod) 
											compiledMethod.
			^ blockDescriptor].	! !

!STypeBucket methodsFor: 'collecting types' stamp: 'mp 5/7/2013 18:12:41.454'!
containerTypeFrom: aContainer

	self subclassResponsibility.! !

!STypeBucket methodsFor: 'monticello conversion' stamp: 'mp 6/15/2011 11:04:30.18'!
convertToSymbols

	self subclassResponsibility.! !

!STypeBucket methodsFor: 'monticello conversion' stamp: 'mp 6/15/2011 11:04:35.674'!
convertToTypes

	self subclassResponsibility.! !

!STypeBucket methodsFor: 'collecting types' stamp: 'mp 5/3/2012 14:44:45.093'!
getTypeFromObject: anObject
	(anObject isCollection or: [anObject isVariableBinding])
		ifTrue: [^ self containerTypeFrom: anObject]
		ifFalse: [^ anObject class]! !

!STypeBucket methodsFor: 'collecting types' stamp: 'mp 5/2/2013 14:13:58.606'!
getTypeFromObject: anObject existing: aType
	SPMPathMap lightContainerTypes
		ifFalse: [^ self getTypeFromObject: anObject].
	aType 
		ifNil: [^ self getTypeFromObject: anObject]
		ifNotNil: [
			(aType class = SContainerType)
				ifTrue: [
					(aType typeOfContainer isNil 
						or: [aType typeOfElements isNil])
							ifTrue: [^ self getTypeFromObject: anObject]
							ifFalse: [^ aType]]
				ifFalse: [^ anObject class]]
	! !

!STypeBucket methodsFor: 'monticello conversion' stamp: 'mp 5/7/2013 18:13:30.315'!
methodToAssoc: aMethodReference
	| blockDescriptor |
	(aMethodReference respondsTo: #methodReference)  
		ifFalse: [^ aMethodReference compiledMethod methodClass name 
					-> aMethodReference methodSymbol]
		ifTrue: [blockDescriptor := aMethodReference copy.
				blockDescriptor embeddingMethod: (self 
								methodToAssoc: (aMethodReference
													embeddingMethod
														methodReference)).
				^ blockDescriptor].

	! !

!STypeBucket methodsFor: 'monticello conversion' stamp: 'mp 5/2/2013 14:14:00.86'!
symbolToType: aSymbolOrContainer
	| container |
	aSymbolOrContainer class = SContainerType
		ifTrue: [	container := aSymbolOrContainer deepCopy.
				container 
					typeOfContainer: (self symbolToType: container typeOfContainer).
				container typeOfElements ifNotNil: [
					container typeOfElements: 
									(self symbolToType: container typeOfElements)].
				container typeOfKeys ifNotNil: [
					container typeOfKeys: (self symbolToType: container typeOfKeys)].
				^ container]
		ifFalse: [
			aSymbolOrContainer = 'nil' ifTrue: [^ nil].
			(aSymbolOrContainer endsWith: ' class')
				ifTrue: [^ (Smalltalk 
							at: (aSymbolOrContainer allButLast: 6) asSymbol) class]
				ifFalse: [^ Smalltalk at: aSymbolOrContainer]]! !

!STypeBucket methodsFor: 'monticello conversion' stamp: 'mp 6/26/2011 19:29:08.053'!
symbolsToTypes: aCollection
	^ aCollection collect: [:each | self symbolToType: each]! !

!STypeBucket methodsFor: 'monticello conversion' stamp: 'mp 5/2/2013 14:14:03.67'!
typeToSymbol: aType
	| container |
	aType class = SContainerType
		ifTrue: [	container := aType deepCopy.
				container 
					typeOfContainer: (self typeToSymbol: container typeOfContainer).
				container typeOfElements ifNotNil: [
					container typeOfElements: 
										(self typeToSymbol: container typeOfElements)].
				container typeOfKeys ifNotNil: [
					container typeOfKeys: (self typeToSymbol: container typeOfKeys)].
				^ container]
		ifFalse: [^ aType name]! !

!STypeBucket methodsFor: 'monticello conversion' stamp: 'mp 6/15/2011 12:10:22.146'!
typesToSymbols: aCollection
	^ aCollection collect: [:each | self typeToSymbol: each]! !

SBucket subclass: #SValueRangeBucket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-ValueRanges'!

!SValueRangeBucket methodsFor: 'properties' stamp: 'mp 5/7/2013 17:57:41.942'!
argumentPropertiesFor: anObject at: aMethodReference index: aNumber
	| requiredPropertyClass storedProperties temporaries |
	requiredPropertyClass := self propertyClassOf: anObject.
	temporaries := self arguments 
						at: aMethodReference 
						ifAbsentPut: (Array 
									new: aMethodReference compiledMethod numTemps).
	storedProperties := temporaries at: aNumber.
	storedProperties
		ifNil: [^ temporaries at: aNumber put: requiredPropertyClass new].
	storedProperties isCollection
		ifTrue: [^ storedProperties 
					detect: [:each | each class = requiredPropertyClass] 
					ifNone: [storedProperties add: requiredPropertyClass new]]
		ifFalse: [^ storedProperties class = requiredPropertyClass
					ifTrue: [storedProperties]
					ifFalse: [(temporaries 
								at: aNumber 
								put: (OrderedCollection 
									with: storedProperties 
									with: requiredPropertyClass new)) last]].! !

!SValueRangeBucket methodsFor: 'properties' stamp: 'mp 5/7/2013 17:57:02.402'!
memberPropertiesFor: anObject at: aClass index: aNumber
	| requiredPropertyClass storedProperties instanceVariables |
	requiredPropertyClass := self propertyClassOf: anObject.
	instanceVariables := self members 
						at: aClass 
						ifAbsentPut: (Array new: aClass allInstVarNames size).
	storedProperties := instanceVariables at: aNumber.
	storedProperties
		ifNil: [^ instanceVariables at: aNumber put: requiredPropertyClass new].
	storedProperties isCollection
		ifTrue: [^ storedProperties 
					detect: [:each | each class = requiredPropertyClass] 
					ifNone: [storedProperties add: requiredPropertyClass new]]
		ifFalse: [^ storedProperties class = requiredPropertyClass
					ifTrue: [storedProperties]
					ifFalse: [(instanceVariables 
								at: aNumber 
								put: (OrderedCollection 
									with: storedProperties 
									with: requiredPropertyClass new)) last]].! !

!SValueRangeBucket methodsFor: 'harvesting' stamp: 'mp 5/7/2013 17:57:51.793'!
noteArgument: anObject index: aNumber in: aMethod
	| rangeProperties |
	rangeProperties := anObject 
							ifNil: [(self arguments 
									at: aMethod methodReference 
									ifAbsent: [^ self])
										at: aNumber]
							ifNotNil: [self 
										argumentPropertiesFor: anObject 
										at: aMethod methodReference
										index: aNumber].
	rangeProperties ifNil: [^ self].					
	rangeProperties isCollection
		ifTrue: [rangeProperties do: [:each | each process: anObject]]
		ifFalse: [rangeProperties process: anObject].! !

!SValueRangeBucket methodsFor: 'harvesting' stamp: 'mp 5/7/2013 17:57:10.703'!
noteMember: anObject for: aNumber in: aClass
	| rangeProperties |
	rangeProperties := anObject 
							ifNil: [(self members
									at: aClass 
									ifAbsent: [^ self])
										at: aNumber]
							ifNotNil: [self 
										memberPropertiesFor: anObject 
										at: aClass
										index: aNumber].
	rangeProperties ifNil: [^ self].
	rangeProperties isCollection
		ifTrue: [rangeProperties do: [:each | each process: anObject]]
		ifFalse: [rangeProperties process: anObject].! !

!SValueRangeBucket methodsFor: 'harvesting' stamp: 'mp 5/7/2013 17:56:02.116'!
noteReturn: anObject in: aMethod
	| rangeProperties |
	rangeProperties := anObject 
							ifNil: [self returns 
									at: aMethod methodReference 
									ifAbsent: [^ self]]
							ifNotNil: [self 
										returnPropertiesFor: anObject 
										at: aMethod methodReference].
	rangeProperties isCollection
		ifTrue: [rangeProperties do: [:each | each process: anObject]]
		ifFalse: [rangeProperties process: anObject].! !

!SValueRangeBucket methodsFor: 'initialize-release' stamp: 'mp 5/7/2013 17:44:22.451'!
postProcessing
	self 
		removeLastObjectsFrom: self arguments;
		removeLastObjectsFrom: self members;
		removeLastObjectsFrom: self returns.
! !

!SValueRangeBucket methodsFor: 'properties' stamp: 'mp 5/2/2012 17:32:32.755'!
propertyClassOf: anObject
	(anObject class includesBehavior: Number)
		ifTrue:[^ SNumbersRangeProperties].
	(anObject class includesBehavior: Character)
		ifTrue:[^ SCharactersRangeProperties].
	(anObject class includesBehavior: String)
		ifTrue:[^ SStringRangeProperties].
	(anObject class includesBehavior: Collection)
		ifTrue:[^ SCollectionsRangeProperties].	
	(anObject class includesBehavior: DateAndTime)
		ifTrue:[^ SDateAndTimeRangeProperties].
	(anObject class includesBehavior: Duration)
		ifTrue:[^ SDurationRangeProperties].
	(anObject class includesBehavior: Stream)
		ifTrue:[^ SStreamRangeProperties].		
	"..."
	^ SDefaultRangeProperties! !

!SValueRangeBucket methodsFor: 'initialize-release' stamp: 'mp 5/4/2012 14:54:21.058'!
removeLastObject: aProperty
	aProperty ifNotNil: [
		aProperty isCollection
			ifTrue: [aProperty do: [:property | property lastObject: nil]]
			ifFalse: [aProperty lastObject: nil]].! !

!SValueRangeBucket methodsFor: 'initialize-release' stamp: 'mp 5/4/2012 14:53:41.69'!
removeLastObjectsFrom: aDictionary
	aDictionary valuesDo: [:values | 
		values isCollection
			ifTrue: [values do: [:each | self removeLastObject: each]]
			ifFalse: [self removeLastObject: values]].! !

!SValueRangeBucket methodsFor: 'properties' stamp: 'mp 5/7/2013 17:55:50.311'!
returnPropertiesFor: anObject at: aMethodReference
	| requiredPropertyClass storedProperties |
	requiredPropertyClass := self propertyClassOf: anObject.
	storedProperties := self returns at: aMethodReference ifAbsent: [nil].
	storedProperties
		ifNil: [^ self returns 	at: aMethodReference put: requiredPropertyClass new].
	storedProperties isCollection
		ifTrue: [^ storedProperties 
					detect: [:each | each class = requiredPropertyClass] 
					ifNone: [storedProperties add: requiredPropertyClass new]]
		ifFalse: [^ storedProperties class = requiredPropertyClass
					ifTrue: [storedProperties]
					ifFalse: [(self returns 
								at: aMethodReference 
								put: (OrderedCollection 
									with: storedProperties 
									with: requiredPropertyClass new)) last]].! !

Object subclass: #SContainerType
	instanceVariableNames: 'typeOfContainer typeOfElements typeOfKeys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-Types'!

!SContainerType class methodsFor: 'instance creation' stamp: 'mp 5/3/2011 14:43:10.545'!
forPoly: aClass

	^ self new
		typeOfContainer:  aClass;
		typeOfElements: Set new;
		typeOfKeys: Set new;
		yourself! !

!SContainerType methodsFor: 'comparing' stamp: 'mp 5/3/2011 13:13:35.071'!
= anObject
	anObject == self ifTrue: [^ true].
	anObject class = self class ifFalse: [^ false].
	^ (((anObject typeOfContainer = self typeOfContainer)
		and: [anObject typeOfElements = self typeOfElements]) 
		and: [anObject typeOfKeys = self typeOfKeys])! !

!SContainerType methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:03:23.991'!
collectionTemplate
	
	^ 'SContract expectElementsOf: <COLLECTION> toBeKindOf: <TYPE>.'! !

!SContainerType methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:03:25.815'!
dictionaryTemplate
	
	^ 'SContract expectKeysOf: <COLLECTION> toBeKindOf: <TYPE>.'! !

!SContainerType methodsFor: 'error handling' stamp: 'tfel 7/22/2011 11:23:27.52'!
doesNotUnderstand: aMessage

	^ (self theNonMetaClass respondsTo: aMessage selector)
		ifTrue: [self theNonMetaClass
						perform: aMessage selector
						withArguments: aMessage arguments]
		ifFalse: [super doesNotUnderstand: aMessage]! !

!SContainerType methodsFor: 'comparing' stamp: 'mp 5/3/2011 13:13:39.417'!
hash
	^ (self typeOfContainer hash 
		bitXor: self typeOfElements hash) 
		bitXor: self typeOfKeys hash! !

!SContainerType methodsFor: 'accessing' stamp: 'mp 5/3/2012 09:18:05.915'!
innerTypeOfElements
	"Return the inner-most typeOfElements, even if this is a container-type with multiple nested collections."
	
	| currentType |
	currentType := self.
	[ currentType isBehavior or: [currentType isNil] ]
		whileFalse: [ currentType := currentType typeOfElements ].
	^ currentType! !

!SContainerType methodsFor: 'contracts' stamp: 'mp 5/14/2013 14:57:28.657'!
print: aString contractsFor: anArgumentName typed: aType with: aBuilder
	| contract |
	(anArgumentName isNil or: [aType isNil]) ifTrue: [^ self].
	(SContract blacklistedTypes includes: aType) ifTrue: [^ self].
	contract := aString 
		copyReplaceTokens: '<COLLECTION>' with: anArgumentName.
	contract := contract copyReplaceTokens: '<TYPE>' with: aType asString.
	aBuilder printSourceLine: contract.! !

!SContainerType methodsFor: 'contracts' stamp: 'mp 5/2/2013 14:12:52.834'!
printChildrenContract: aCollectionType with: aBlock
	| type |
	aCollectionType ifNotNil: [
		(aCollectionType isKindOf: SContainerType)
			ifTrue: [type := aCollectionType typeOfContainer]
			ifFalse: [type := aCollectionType].
		aBlock value: type].	! !

!SContainerType methodsFor: 'contracts' stamp: 'mp 1/21/2013 16:19:29.831'!
printContractFor: anArgumentName with: aBuilder
	self 
		printChildrenContract: self typeOfContainer 
			with: [:type | type printContractFor: anArgumentName with: aBuilder];
		printChildrenContract: self typeOfKeys 
			with: [:type | self 
							print: self dictionaryTemplate 
							contractsFor: anArgumentName 
							typed: type 
							with: aBuilder];
		printChildrenContract: self typeOfElements 
			with: [:type | self 
							print: self collectionTemplate 
							contractsFor: anArgumentName 
							typed: type 
							with: aBuilder].! !

!SContainerType methodsFor: 'printing' stamp: 'mp 5/3/2011 16:21:04.408'!
printString
	| stream |
	stream := WriteStream on: ''.
	stream nextPutAll: self typeOfContainer asString.
	(self typeOfElements notNil or: [self typeOfKeys notNil])
		ifTrue: [stream nextPutAll: ' of '].
	self typeOfKeys ifNotNil: [stream 
								nextPutAll: self typeOfKeys asString;
								nextPutAll: ' --> '].
	self typeOfElements ifNotNil: [stream nextPutAll: self typeOfElements asString].
	^ stream contents! !

!SContainerType methodsFor: 'class membership' stamp: 'mp 11/1/2011 14:45:40.247'!
respondsTo: aSelector
	
	^ (super respondsTo: aSelector) or: [ self theNonMetaClass respondsTo: aSelector ]! !

!SContainerType methodsFor: 'printing' stamp: 'tfel 7/5/2012 14:27:40.867'!
storeString

	^ String streamContents: [:stream |
		stream
			nextPutAll: '(';
			nextPutAll: self class name;
			space;
			nextPutAll: 'new typeOfContainer: ';
			nextPutAll: self typeOfContainer storeString;
			nextPutAll: '; typeOfElements: ';
			nextPutAll: self typeOfElements storeString;
			nextPutAll: '; typeOfKeys: ';
			nextPutAll: self typeOfKeys storeString;
			nextPutAll: '; yourself)']! !

!SContainerType methodsFor: 'accessing' stamp: 'fb 5/12/2011 14:29:32.289'!
theMetaClass
	^ self typeOfElements class! !

!SContainerType methodsFor: 'accessing' stamp: 'fb 5/12/2011 14:29:15.32'!
theNonMetaClass
	^ self typeOfElements! !

!SContainerType methodsFor: 'accessing' stamp: 'mp 5/2/2011 11:33:22.639'!
typeOfContainer
	"Answer the value of typeOfContainer"

	^ typeOfContainer! !

!SContainerType methodsFor: 'accessing' stamp: 'mp 5/2/2011 11:33:22.656'!
typeOfContainer: anObject
	"Set the value of typeOfContainer"

	typeOfContainer := anObject! !

!SContainerType methodsFor: 'accessing' stamp: 'mp 5/3/2011 14:36:37.804'!
typeOfElements
	"Answer the value of typeOfElements"

	^ typeOfElements! !

!SContainerType methodsFor: 'accessing' stamp: 'mp 5/3/2011 13:12:51.847'!
typeOfElements: anObject
	"Set the value of typeOfElements"

	typeOfElements := anObject! !

!SContainerType methodsFor: 'accessing' stamp: 'mp 5/3/2011 14:36:41.315'!
typeOfKeys
	"Answer the value of typeOfKeys"

	^ typeOfKeys! !

!SContainerType methodsFor: 'accessing' stamp: 'mp 5/3/2011 13:12:51.881'!
typeOfKeys: anObject
	"Set the value of typeOfKeys"

	typeOfKeys := anObject! !

Object subclass: #SDefaultRangeProperties
	instanceVariableNames: 'constantValue lastObject nilAllowed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-ValueRanges'!

SDefaultRangeProperties subclass: #SCharactersRangeProperties
	instanceVariableNames: 'range includesLetters includesDigits includesSeparators includesSpecials lowercase uppercase httpSafe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-ValueRanges'!

!SCharactersRangeProperties class methodsFor: 'pathMap-hooks' stamp: 'mp 2/9/2012 15:01:35.731'!
label
	^ 'Characters'! !

!SCharactersRangeProperties methodsFor: 'comparing' stamp: 'mp 7/20/2012 11:12:25.519'!
= anObject
	^ ((((((((super = anObject) 
		and: [self range = anObject range])
		and: [self includesLetters = anObject includesLetters])
		and: [self includesDigits = anObject includesDigits])
		and: [self includesSeparators = anObject includesSeparators])
		and: [self includesSpecials = anObject includesSpecials])
		and: [self lowercase = anObject lowercase])
		and: [self uppercase = anObject uppercase])
		and: [self httpSafe = anObject httpSafe]	       ! !

!SCharactersRangeProperties methodsFor: 'comparing' stamp: 'mp 5/3/2013 13:28:45.038'!
hash
	^ (((((((super hash 
		bitXor: self range hash)
		bitXor: self includesLetters hash)
		bitXor: self includesDigits hash)
		bitXor: self includesSeparators hash)
		bitXor: self includesSpecials hash)
		bitXor: self lowercase hash)
		bitXor: self uppercase hash)
		bitXor: self httpSafe hash	       ! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.863'!
httpSafe
	"Answer the value of httpSafe"

	^ httpSafe! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.879'!
httpSafe: anObject
	"Set the value of httpSafe"

	httpSafe := anObject! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 16:50:38.561'!
includesDigits
	"Answer the value of includesDigits"

	^ includesDigits! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 16:50:38.577'!
includesDigits: anObject
	"Set the value of includesDigits"

	includesDigits := anObject! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.681'!
includesLetters
	"Answer the value of includesLetters"

	^ includesLetters! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.696'!
includesLetters: anObject
	"Set the value of includesLetters"

	includesLetters := anObject! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.742'!
includesSeparators
	"Answer the value of includesSeparators"

	^ includesSeparators! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.758'!
includesSeparators: anObject
	"Set the value of includesSeparators"

	includesSeparators := anObject! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.773'!
includesSpecials
	"Answer the value of includesSpecials"

	^ includesSpecials! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.789'!
includesSpecials: anObject
	"Set the value of includesSpecials"

	includesSpecials := anObject! !

!SCharactersRangeProperties methodsFor: 'initialize-release' stamp: 'mp 2/8/2012 16:50:47.494'!
initialize
	super initialize.
	self 
		range: nil;
		includesLetters: false; 
		includesDigits: false; 
		includesSeparators: false;
		includesSpecials: false; 
		lowercase: false;
		uppercase: false;
		httpSafe: true.! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.804'!
lowercase
	"Answer the value of lowercase"

	^ lowercase! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.819'!
lowercase: anObject
	"Set the value of lowercase"

	lowercase := anObject! !

!SCharactersRangeProperties methodsFor: 'contracts' stamp: 'mp 3/21/2012 14:36:44.056'!
printContractFor: anArgumentName with: aBuilder
	| type |
	type := Character.
	self printRange: self range
					  for: anArgumentName 
					  property: '#charCode'
					  ofType: type with: aBuilder.
	self httpSafe
		ifTrue: [self printIs: '#isSafeForHTTP' 
					for: anArgumentName ofType: type with: aBuilder].
	self includesLetters
		ifFalse: [self printIsNot: '#isLetter'
					for: anArgumentName ofType: type with: aBuilder].
	self includesDigits
		ifFalse: [self printIsNot: '#isDigit' 
					for: anArgumentName ofType: type with: aBuilder].	
	self includesSeparators
		ifFalse: [self printIsNot: '#isSeparator' 
					for: anArgumentName ofType: type with: aBuilder].	
	self includesSpecials
		ifFalse: [self printIsNot: '#isSpecial'
					for: anArgumentName ofType: type with: aBuilder].			
	self lowercase
		ifFalse: [self printIsNot: '#isLowercase' 
					for: anArgumentName ofType: type with: aBuilder].	
	self uppercase
		ifFalse: [self printIsNot: '#isUppercase' 
					for: anArgumentName ofType: type with: aBuilder].																	! !

!SCharactersRangeProperties methodsFor: 'processing' stamp: 'mp 2/8/2012 16:55:32.652'!
process: anObject
	super process: anObject.
	anObject 
		ifNotNil: [self 
					processRange;
					processLetters;
					processNonLetters;
					processHttpSafety].! !

!SCharactersRangeProperties methodsFor: 'processing' stamp: 'mp 2/8/2012 17:10:18.974'!
processHttpSafety
	self lastObject isSafeForHTTP
		ifFalse: [self httpSafe: false].! !

!SCharactersRangeProperties methodsFor: 'processing' stamp: 'mp 2/8/2012 16:56:11.621'!
processLetters
	self lastObject isLetter
		ifTrue: [self includesLetters: true.
				self lastObject isLowercase
					ifTrue: [self lowercase: true].
				self lastObject isUppercase
					ifTrue: [self uppercase: true]].
		! !

!SCharactersRangeProperties methodsFor: 'processing' stamp: 'mp 2/8/2012 16:56:30.485'!
processNonLetters
	self lastObject isDigit
		ifTrue: [self includesDigits: true].				
	self lastObject isSeparator
		ifTrue: [self includesSeparators: true].
	self lastObject isSpecial
		ifTrue: [self includesSpecials: true].! !

!SCharactersRangeProperties methodsFor: 'processing' stamp: 'mp 2/8/2012 17:04:28.645'!
processRange
	| charCode |
	charCode := self lastObject charCode.
	self range 
		ifNil: [self range: charCode]
		ifNotNil: [self range isInterval
					ifTrue: [(self range rangeIncludes: charCode)
								ifFalse: [self range: (Interval 
											from: (self range start min: charCode) 
											to: (self range stop max: charCode))]]
					ifFalse: [self range: (Interval 
								from: (self range min: charCode) 
								to: (self range max: charCode))]].! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.65'!
range
	"Answer the value of range"

	^ range! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.666'!
range: anObject
	"Set the value of range"

	range := anObject! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.834'!
uppercase
	"Answer the value of uppercase"

	^ uppercase! !

!SCharactersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 14:55:22.849'!
uppercase: anObject
	"Set the value of uppercase"

	uppercase := anObject! !

SDefaultRangeProperties subclass: #SCollectionsRangeProperties
	instanceVariableNames: 'maxNumberOfElements fixedSize emptyAllowed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-ValueRanges'!

!SCollectionsRangeProperties class methodsFor: 'pathMap-hooks' stamp: 'mp 2/10/2012 09:42:12.065'!
label
	^ 'Collections'! !

!SCollectionsRangeProperties methodsFor: 'comparing' stamp: 'mp 7/11/2012 15:25:57.99'!
= anObject
	^ (((super = anObject) 
		and: [self maxNumberOfElements = anObject maxNumberOfElements])
		and: [self fixedSize = anObject fixedSize])
		and: [self emptyAllowed = anObject emptyAllowed]! !

!SCollectionsRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 09:47:15.795'!
emptyAllowed
	"Answer the value of emptyAllowed"

	^ emptyAllowed! !

!SCollectionsRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 09:47:15.81'!
emptyAllowed: anObject
	"Set the value of emptyAllowed"

	emptyAllowed := anObject! !

!SCollectionsRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 09:47:15.765'!
fixedSize
	"Answer the value of fixedSize"

	^ fixedSize! !

!SCollectionsRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 09:47:15.78'!
fixedSize: anObject
	"Set the value of fixedSize"

	fixedSize := anObject! !

!SCollectionsRangeProperties methodsFor: 'comparing' stamp: 'mp 5/3/2013 13:28:58.107'!
hash
	^ ((super hash 
		bitXor: self maxNumberOfElements hash)
		bitXor: self fixedSize hash)
		bitXor: self emptyAllowed hash! !

!SCollectionsRangeProperties methodsFor: 'initialize-release' stamp: 'mp 2/10/2012 09:48:02.126'!
initialize
	super initialize.
	self 
		maxNumberOfElements: 0;
		fixedSize: true;
		emptyAllowed: false.! !

!SCollectionsRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 09:47:15.735'!
maxNumberOfElements
	"Answer the value of maxNumberOfElements"

	^ maxNumberOfElements! !

!SCollectionsRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 09:47:15.751'!
maxNumberOfElements: anObject
	"Set the value of maxNumberOfElements"

	maxNumberOfElements := anObject! !

!SCollectionsRangeProperties methodsFor: 'contracts' stamp: 'mp 3/21/2012 13:01:35.627'!
printContractFor: anArgumentName with: aBuilder
	| type |
	type := Collection.
	self maxNumberOfElements > 0
		ifTrue: [self printLength: self maxNumberOfElements 
					for: anArgumentName ofType: type with: aBuilder].
	self emptyAllowed
		ifFalse: [self printIsNot: '#isEmpty' 
					for: anArgumentName ofType: type with: aBuilder].	! !

!SCollectionsRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 09:55:07.004'!
process: anObject
	super process: anObject.
	anObject
		ifNotNil: [self 
					processCollectionSize;
					processEmptyProperty].! !

!SCollectionsRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 09:55:32.274'!
processCollectionSize
	self maxNumberOfElements: (self maxNumberOfElements max: self lastObject size).
	self lastObject size = self maxNumberOfElements
		ifFalse: [self fixedSize: false].! !

!SCollectionsRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 09:55:43.637'!
processEmptyProperty
	self lastObject ifEmpty: [self emptyAllowed: true]! !

SDefaultRangeProperties subclass: #SDateAndTimeRangeProperties
	instanceVariableNames: 'minDate maxDate dayOfWeekNames isLeapYear timeZones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-ValueRanges'!

!SDateAndTimeRangeProperties class methodsFor: 'pathMap-hooks' stamp: 'mp 2/10/2012 11:36:16.041'!
label
	^ 'DateAndTime'! !

!SDateAndTimeRangeProperties methodsFor: 'comparing' stamp: 'mp 6/7/2013 10:56:53.589'!
= anObject
	^ (((((super = anObject) 
		and: [self minDate asSeconds = anObject minDate asSeconds])
		and: [self maxDate asSeconds = anObject maxDate asSeconds])
		and: [self dayOfWeekNames = anObject dayOfWeekNames])
		and: [self isLeapYear = anObject isLeapYear])
		and: [self timeZones = anObject timeZones]
		
	    ! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:21:40.674'!
dayOfWeekNames
	"Answer the value of dayOfWeekNames"

	^ dayOfWeekNames! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:21:40.689'!
dayOfWeekNames: anObject
	"Set the value of dayOfWeekNames"

	dayOfWeekNames := anObject! !

!SDateAndTimeRangeProperties methodsFor: 'comparing' stamp: 'mp 5/3/2013 13:29:11.76'!
hash
	^ ((((super hash 
		bitXor: self minDate hash)
		bitXor: self maxDate hash)
		bitXor: self dayOfWeekNames hash)
		bitXor: self isLeapYear hash)
		bitXor: self timeZones hash
		
	    ! !

!SDateAndTimeRangeProperties methodsFor: 'initialize-release' stamp: 'mp 2/10/2012 11:30:38.707'!
initialize
	super initialize.
	self 
		minDate: nil;
		maxDate: nil;
		dayOfWeekNames: Set new;
		isLeapYear: false;
		timeZones: Set new.! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:21:40.705'!
isLeapYear
	"Answer the value of isLeapYear"

	^ isLeapYear! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:21:40.72'!
isLeapYear: anObject
	"Set the value of isLeapYear"

	isLeapYear := anObject! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:30:18.547'!
maxDate
	"Answer the value of maxDate"

	^ maxDate! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:30:18.563'!
maxDate: anObject
	"Set the value of maxDate"

	maxDate := anObject! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:30:18.516'!
minDate
	"Answer the value of minDate"

	^ minDate! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:30:18.532'!
minDate: anObject
	"Set the value of minDate"

	minDate := anObject! !

!SDateAndTimeRangeProperties methodsFor: 'contracts' stamp: 'mp 3/21/2012 15:00:24.939'!
printContractFor: anArgumentName with: aBuilder
	| type |
	type := DateAndTime.
	(self minDate notNil and: [self maxDate notNil])
		ifTrue: [self printRangeFrom: self minDate to: self maxDate 
					for: anArgumentName ofType: type with: aBuilder].	
	self timeZones 
		ifNotEmpty: [self printIncludes: self timeZones asArray
						for: anArgumentName 
						property: '#timeZoneName'
						ofType: type with: aBuilder].
	self dayOfWeekNames 
		ifNotEmpty: [self printIncludes: self dayOfWeekNames asArray
						for: anArgumentName 
						property: '#dayOfWeekName'
						ofType: type with: aBuilder].
	self isLeapYear
		ifFalse: [self printIsNot: '#isLeapYear' 
					for: anArgumentName ofType: type with: aBuilder].					! !

!SDateAndTimeRangeProperties methodsFor: 'contracts' stamp: 'mp 6/7/2013 13:01:19.255'!
printRangeFrom: start to: stop for: anArgumentName ofType: aClass with: aBuilder
	aBuilder printSourceLine: 
		('SContract expect: ', anArgumentName, 
		' ofType: ', aClass asString,
		' isBetween: DateAndTime now + ''', start asString, ''' asDuration', 
		' and: DateAndTime now + ''', stop asString, ''' asDuration.').! !

!SDateAndTimeRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 11:31:06.234'!
process: anObject
	super process: anObject.
	anObject 
		ifNotNil: [self
					processRangeProperty;
					processDayOfWeekNamesProperty;
					processLeapYearProperty;
					processTimeZoneProperty].! !

!SDateAndTimeRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 11:27:25.233'!
processDayOfWeekNamesProperty
	self dayOfWeekNames add: self lastObject dayOfWeekName.! !

!SDateAndTimeRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 11:28:05.866'!
processLeapYearProperty
	self lastObject isLeapYear
		ifTrue: [self isLeapYear: true].! !

!SDateAndTimeRangeProperties methodsFor: 'processing' stamp: 'mp 6/7/2013 12:45:56.201'!
processRangeProperty
	| duration offset |
	duration := self lastObject - DateAndTime now.
	self minDate 
		ifNil: [self minDate: duration].
	self maxDate 
		ifNil: [self maxDate: duration].
	offset := 0.05. "5% buffer for timing differences"
	self 
		minDate: (self minDate min: duration - 
					(duration * offset) abs - (Duration seconds: 5));
		maxDate: (self maxDate max: duration + 
					(duration * offset) abs + (Duration seconds: 5)).! !

!SDateAndTimeRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 11:37:59.228'!
processTimeZoneProperty
	self timeZones add: self lastObject timeZoneName! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:21:40.735'!
timeZones
	"Answer the value of timeZones"

	^ timeZones! !

!SDateAndTimeRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:21:40.751'!
timeZones: anObject
	"Set the value of timeZones"

	timeZones := anObject! !

!SDefaultRangeProperties class methodsFor: 'pathMap-hooks' stamp: 'mp 2/9/2012 15:01:05.556'!
label
	^ 'Other Objects'! !

!SDefaultRangeProperties methodsFor: 'comparing' stamp: 'mp 7/11/2012 12:27:50.221'!
= anObject
	anObject == self ifTrue: [^ true].
	anObject class = self class ifFalse: [^ false].
	^ (anObject constantValue = self constantValue)
		and: [anObject nilAllowed = self nilAllowed]! !

!SDefaultRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:06:09.643'!
constantValue
	"Answer the value of constantValue"

	^ constantValue! !

!SDefaultRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:06:09.659'!
constantValue: anObject
	"Set the value of constantValue"

	constantValue := anObject! !

!SDefaultRangeProperties methodsFor: 'comparing' stamp: 'mp 7/11/2012 12:28:53.049'!
hash
	^ self constantValue hash bitXor: self nilAllowed hash! !

!SDefaultRangeProperties methodsFor: 'initialize-release' stamp: 'mp 2/6/2012 17:09:56.639'!
initialize
	self 
		constantValue: true;
		lastObject: nil;
		nilAllowed: false.! !

!SDefaultRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:08:34.476'!
lastObject
	"Answer the value of lastObject"

	^ lastObject! !

!SDefaultRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:08:34.493'!
lastObject: anObject
	"Set the value of lastObject"

	lastObject := anObject! !

!SDefaultRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:06:09.674'!
nilAllowed
	"Answer the value of nilAllowed"

	^ nilAllowed! !

!SDefaultRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:06:09.688'!
nilAllowed: anObject
	"Set the value of nilAllowed"

	nilAllowed := anObject! !

!SDefaultRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:04:22.293'!
printContractFor: anArgumentName with: aBuilder

	self nilAllowed
		ifFalse: [aBuilder printSourceLine: 
					('SContract expectNotNil: ', anArgumentName, '.')].! !

!SDefaultRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:04:24.015'!
printIncluded: aColl for: anArgumentName ofType: aClass with: aBuilder
	aBuilder printSourceLine: 
		('SContract expect: ', anArgumentName,
		' ofType: ', aClass asString,
		' isIncludedIn: ', aColl asString, '.').! !

!SDefaultRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:04:25.735'!
printIncludes: aColl for: anArgumentName ofType: aClass with: aBuilder
	aBuilder printSourceLine: 
		('SContract expect: ', anArgumentName,
		' ofType: ', aClass asString,
		' includes: ', aColl asString, '.').! !

!SDefaultRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:04:28.045'!
printIncludes: aCollection for: anArgumentName property: aString ofType: aClass with: aBuilder

	aBuilder printSourceLine: 
		('SContract expect: ', anArgumentName,
		' ofType: ', aClass asString,
		' property: ', aString,		
		' includes: ', aCollection asString, '.').! !

!SDefaultRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:04:29.884'!
printIs: anObject for: anArgumentName ofType: aClass with: aBuilder
	aBuilder printSourceLine: 
		('SContract expect: ', anArgumentName, 
		' ofType: ', aClass asString,
		' is: ', anObject, '.').! !

!SDefaultRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:04:31.553'!
printIsNot: anObject for: anArgumentName ofType: aClass with: aBuilder
	aBuilder printSourceLine: 
		('SContract expect: ', anArgumentName, 
		' ofType: ', aClass asString,
		' isNot: ', anObject, '.').! !

!SDefaultRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:04:33.104'!
printLength: aNumber for: anArgumentName ofType: aClass with: aBuilder.
	aBuilder printSourceLine: 
		('SContract expectSize: ', anArgumentName,
		' ofType: ', aClass asString,
		' isLessThan: ', aNumber, '.').! !

!SDefaultRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:04:35.159'!
printRange: aRange for: anArgumentName ofType: aClass with: aBuilder
	aRange ifNotNil: [
		aRange isInterval 
			ifTrue: [aBuilder printSourceLine: 
						('SContract expect: ', anArgumentName, 
						' ofType: ', aClass asString,
						' isBetween: ', aRange start ,' and: ', aRange stop, '.')]
			ifFalse: [self printIs: aRange 
						 for: anArgumentName 
						 ofType: aClass 
						 with: aBuilder]].! !

!SDefaultRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:12:32.456'!
printRange: aRange for: anArgumentName property: aString ofType: aClass with: aBuilder
	aRange ifNotNil: [
		aRange isInterval 
			ifTrue: [aBuilder printSourceLine: 
						('SContract expect: ', anArgumentName, 
						' ofType: ', aClass asString,
						' property: ', aString,						
						' isBetween: ', aRange start ,' and: ', aRange stop, '.')]
			ifFalse: [aBuilder printSourceLine: 
						('SContract expect: ', anArgumentName, 
						' ofType: ', aClass asString,
						' property: ', aString,						
						' isBetween: ', aRange, ' and: ', aRange, '.')]].! !

!SDefaultRangeProperties methodsFor: 'processing' stamp: 'mp 5/2/2012 17:49:22.954'!
process: anObject
	anObject 
		ifNil: [self nilAllowed: true]
		ifNotNil: [
			self lastObject
				ifNotNil: [self lastObject = anObject
							ifFalse: [self constantValue: false]].
			self lastObject: anObject].! !

SDefaultRangeProperties subclass: #SDurationRangeProperties
	instanceVariableNames: 'secondsRange nanoRange positive negative isZero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-ValueRanges'!

!SDurationRangeProperties class methodsFor: 'pathMap-hooks' stamp: 'mp 2/10/2012 11:46:55.364'!
label
	^ 'Duration'! !

!SDurationRangeProperties methodsFor: 'comparing' stamp: 'mp 7/20/2012 11:16:03.812'!
= anObject
	^ (((((super = anObject) 
		and: [self secondsRange = anObject secondsRange])
		and: [self nanoRange = anObject nanoRange])
		and: [self positive = anObject positive])
		and: [self negative = anObject negative])
		and: [self isZero = anObject isZero]    ! !

!SDurationRangeProperties methodsFor: 'comparing' stamp: 'mp 5/3/2013 13:29:23.731'!
hash
	^ ((((super hash 
		bitXor: self secondsRange hash)
		bitXor: self nanoRange hash)
		bitXor: self positive hash)
		bitXor: self negative hash)
		bitXor: self isZero hash    ! !

!SDurationRangeProperties methodsFor: 'initialize-release' stamp: 'mp 2/10/2012 11:51:17.291'!
initialize
	super initialize.
	self 
		secondsRange: nil;
		nanoRange: nil;
		positive: false;
		negative: false;
		isZero: false.! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:51:09.294'!
isZero
	"Answer the value of isZero"

	^ isZero! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:51:09.311'!
isZero: anObject
	"Set the value of isZero"

	isZero := anObject! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:46:42.072'!
nanoRange
	"Answer the value of nanoRange"

	^ nanoRange! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:46:42.087'!
nanoRange: anObject
	"Set the value of nanoRange"

	nanoRange := anObject! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:46:42.133'!
negative
	"Answer the value of negative"

	^ negative! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:46:42.149'!
negative: anObject
	"Set the value of negative"

	negative := anObject! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:46:42.102'!
positive
	"Answer the value of positive"

	^ positive! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:46:42.117'!
positive: anObject
	"Set the value of positive"

	positive := anObject! !

!SDurationRangeProperties methodsFor: 'contracts' stamp: 'mp 3/21/2012 14:34:57.464'!
printContractFor: anArgumentName with: aBuilder
	| type |
	type := Duration.
	self secondsRange 
		ifNotNil: [self printRange: self secondsRange
					  for: anArgumentName 
					  property: '#rawSeconds'
					  ofType: type with: aBuilder].
	self nanoRange 
		ifNotNil: [self printRange: self nanoRange
					  for: anArgumentName 
					  property: '#nanoSeconds'
					  ofType: type with: aBuilder].				
	self isZero
		ifFalse: [self printIsNot: '#isZero' 
					for: anArgumentName ofType: type with: aBuilder].! !

!SDurationRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 12:00:54.067'!
process: anObject
	super process: anObject.
	anObject 
		ifNotNil: [self
					processSecondsRangeProperties;
					processNanosRangeProperties;
					processSignProperty;
					processZeroProperty].! !

!SDurationRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 12:12:36.38'!
processNanosRangeProperties
	| nanos |
	nanos := self lastObject nanoSeconds.
	self nanoRange 
		ifNil: [self nanoRange: nanos]
		ifNotNil: [self nanoRange isInterval
					ifTrue: [(self nanoRange rangeIncludes: nanos)
								ifFalse: [self nanoRange: (Interval 
											from: (self nanoRange start min: nanos) 
											to: (self nanoRange stop max: nanos))]]
					ifFalse: [self nanoRange: (Interval 
								from: (self nanoRange min: nanos) 
								to: (self nanoRange max: nanos))]].! !

!SDurationRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 12:13:16.88'!
processSecondsRangeProperties
	| seconds |
	seconds := self lastObject rawSeconds.
	self secondsRange 
		ifNil: [self secondsRange: seconds]
		ifNotNil: [self secondsRange isInterval
					ifTrue: [(self secondsRange rangeIncludes: seconds)
								ifFalse: [self secondsRange: (Interval 
									from: (self secondsRange start min: seconds) 
									to: (self secondsRange stop max: seconds))]]
					ifFalse: [self secondsRange: (Interval 
								from: (self secondsRange min: seconds) 
								to: (self secondsRange max: seconds))]].! !

!SDurationRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 11:50:06.923'!
processSignProperty
	self lastObject positive
		ifTrue: [self positive: true].
	self lastObject negative
		ifTrue: [self negative: true].
! !

!SDurationRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 11:52:00.091'!
processZeroProperty
	self lastObject isZero
		ifTrue: [self isZero: true].! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:46:42.041'!
secondsRange
	"Answer the value of secondsRange"

	^ secondsRange! !

!SDurationRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 11:46:42.056'!
secondsRange: anObject
	"Set the value of secondsRange"

	secondsRange := anObject! !

SDefaultRangeProperties subclass: #SNumbersRangeProperties
	instanceVariableNames: 'range includesZero positive negative'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-ValueRanges'!

!SNumbersRangeProperties class methodsFor: 'pathMap-hooks' stamp: 'mp 2/9/2012 15:01:51.813'!
label
	^ 'Numbers'! !

!SNumbersRangeProperties methodsFor: 'comparing' stamp: 'mp 7/11/2012 15:24:06.288'!
= anObject
	^ ((((super = anObject) 
		and: [self range = anObject range])
		and: [self includesZero = anObject includesZero])
		and: [self positive = anObject positive])
		and: [self negative = anObject negative]! !

!SNumbersRangeProperties methodsFor: 'comparing' stamp: 'mp 5/3/2013 13:31:08.065'!
hash
	^ (((super hash 
		bitXor: self range hash)
		bitXor: self includesZero hash)
		bitXor: self positive hash)
		bitXor: self negative hash! !

!SNumbersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:29:29.059'!
includesZero
	"Answer the value of includesZero"

	^ includesZero! !

!SNumbersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:29:29.073'!
includesZero: anObject
	"Set the value of includesZero"

	includesZero := anObject! !

!SNumbersRangeProperties methodsFor: 'initialize-release' stamp: 'mp 2/7/2012 17:51:41.236'!
initialize
	super initialize.
	self 
		range: nil;
		includesZero: false;
		positive: false;
		negative: false.! !

!SNumbersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:29:29.116'!
negative
	"Answer the value of negative"

	^ negative! !

!SNumbersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:29:29.131'!
negative: anObject
	"Set the value of negative"

	negative := anObject! !

!SNumbersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:29:29.087'!
positive
	"Answer the value of positive"

	^ positive! !

!SNumbersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:29:29.102'!
positive: anObject
	"Set the value of positive"

	positive := anObject! !

!SNumbersRangeProperties methodsFor: 'contracts' stamp: 'mp 3/21/2012 11:27:58.103'!
printContractFor: anArgumentName with: aBuilder
	| type |
	type := Number.
	self printRange: self range for: anArgumentName ofType: type with: aBuilder.
	self includesZero
		ifFalse: [self printIsNot: 0 for: anArgumentName ofType: type with: aBuilder].! !

!SNumbersRangeProperties methodsFor: 'processing' stamp: 'mp 2/7/2012 17:51:11.513'!
process: anObject
	super process: anObject.
	anObject 
		ifNotNil: [self
					processZeroProperty;
					processPositiveProperty;
					processNegativeProperty;
					processRangeProperty].! !

!SNumbersRangeProperties methodsFor: 'processing' stamp: 'mp 2/7/2012 17:47:02.848'!
processNegativeProperty
	self lastObject < 0
		ifTrue: [self negative: true].! !

!SNumbersRangeProperties methodsFor: 'processing' stamp: 'mp 2/7/2012 17:46:39.249'!
processPositiveProperty
	self lastObject  > 0
		ifTrue: [self positive: true].! !

!SNumbersRangeProperties methodsFor: 'processing' stamp: 'mp 2/7/2012 17:50:24.324'!
processRangeProperty
	self range 
		ifNil: [self range: self lastObject]
		ifNotNil: [self range isInterval
					ifTrue: [(self range rangeIncludes: self lastObject)
								ifFalse: [self range: (Interval 
											from: (self range start min: self lastObject) 
											to: (self range stop max: self lastObject))]]
					ifFalse: [self range: (Interval 
								from: (self range min: self lastObject) 
								to: (self range max: self lastObject))]].! !

!SNumbersRangeProperties methodsFor: 'processing' stamp: 'mp 2/7/2012 17:46:07.466'!
processZeroProperty
	self lastObject = 0 
		ifTrue: [self includesZero: true].	! !

!SNumbersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:29:29.029'!
range
	"Answer the value of range"

	^ range! !

!SNumbersRangeProperties methodsFor: 'accessing' stamp: 'mp 2/6/2012 17:29:29.044'!
range: anObject
	"Set the value of range"

	range := anObject! !

SDefaultRangeProperties subclass: #SStreamRangeProperties
	instanceVariableNames: 'isClosed contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-ValueRanges'!

!SStreamRangeProperties class methodsFor: 'pathMap-hooks' stamp: 'mp 2/10/2012 14:03:20.499'!
label
	^ 'Stream'! !

!SStreamRangeProperties methodsFor: 'comparing' stamp: 'mp 7/20/2012 11:18:07.288'!
= anObject
	^ ((super = anObject) 
		and: [self isClosed = anObject isClosed])
		and: [self contents = anObject contents]! !

!SStreamRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 14:05:38.503'!
contents
	"Answer the value of contents"

	^ contents! !

!SStreamRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 14:05:38.518'!
contents: anObject
	"Set the value of contents"

	contents := anObject! !

!SStreamRangeProperties methodsFor: 'comparing' stamp: 'mp 5/3/2013 13:31:16.552'!
hash
	^ (super hash 
		bitXor: self isClosed hash)
		bitXor: self contents hash! !

!SStreamRangeProperties methodsFor: 'initialize-release' stamp: 'mp 2/10/2012 14:05:12.491'!
initialize
	super initialize.
	self 
		isClosed: false;
		contents: Set new.! !

!SStreamRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 14:05:38.472'!
isClosed
	"Answer the value of isClosed"

	^ isClosed! !

!SStreamRangeProperties methodsFor: 'accessing' stamp: 'mp 2/10/2012 14:05:38.488'!
isClosed: anObject
	"Set the value of isClosed"

	isClosed := anObject! !

!SStreamRangeProperties methodsFor: 'contracts' stamp: 'mp 3/21/2012 14:19:04.28'!
printContractFor: anArgumentName with: aBuilder
	| type |
	type := Stream.
	self isClosed
		ifFalse: [self printIsNot: '#closed' 
					for: anArgumentName ofType: type with: aBuilder].
	self contents 
		ifNotEmpty: [self printIncludes: self contents asArray
						for: anArgumentName 
						property: '#''contents class'''
						ofType: type with: aBuilder].
! !

!SStreamRangeProperties methodsFor: 'processing' stamp: 'mp 2/10/2012 14:07:09.58'!
process: anObject
	super process: anObject.
	anObject 
		ifNotNil: [
			self lastObject closed
				ifTrue: [self isClosed: true].
			self contents add: self lastObject contents class].! !

SDefaultRangeProperties subclass: #SStringRangeProperties
	instanceVariableNames: 'spellingOkay length includesNumbers includesSeparators isAsciiString contentTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester-ValueRanges'!

!SStringRangeProperties class methodsFor: 'pathMap-hooks' stamp: 'mp 2/9/2012 15:02:00.595'!
label
	^ 'Strings'! !

!SStringRangeProperties methodsFor: 'comparing' stamp: 'mp 7/11/2012 15:28:04.319'!
= anObject
	^ ((((((super = anObject) 
		and: [self spellingOkay = anObject spellingOkay])
		and: [self length = anObject length])
		and: [self includesNumbers = anObject includesNumbers])
		and: [self includesSeparators = anObject includesSeparators])
		and: [self isAsciiString = anObject isAsciiString])
		and: [self contentTypes = anObject contentTypes]  ! !

!SStringRangeProperties methodsFor: 'processing' stamp: 'mp 2/8/2012 18:15:18.093'!
check: aSymbol
	([self lastObject perform: aSymbol] on: Error do: [nil])
		ifNotNil: [self contentTypes add: aSymbol].! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 18:15:04.503'!
contentTypes
	"Answer the value of contentTypes"

	^ contentTypes! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 18:15:04.518'!
contentTypes: anObject
	"Set the value of contentTypes"

	contentTypes := anObject! !

!SStringRangeProperties methodsFor: 'comparing' stamp: 'mp 5/3/2013 13:31:33.46'!
hash
	^ (((((super hash 
		bitXor: self spellingOkay hash)
		bitXor: self length hash)
		bitXor: self includesNumbers hash)
		bitXor: self includesSeparators hash)
		bitXor: self isAsciiString hash)
		bitXor: self contentTypes hash  ! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:25:02.254'!
includesNumbers
	"Answer the value of includesNumbers"

	^ includesNumbers! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:25:02.269'!
includesNumbers: anObject
	"Set the value of includesNumbers"

	includesNumbers := anObject! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:46:56.57'!
includesSeparators
	"Answer the value of includesSeparators"

	^ includesSeparators! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:46:56.586'!
includesSeparators: anObject
	"Set the value of includesSeparators"

	includesSeparators := anObject! !

!SStringRangeProperties methodsFor: 'initialize-release' stamp: 'mp 2/8/2012 18:15:12.985'!
initialize
	super initialize.
	self 
		spellingOkay: true; 
		length: 0; 
		includesNumbers: false; 
		includesSeparators: false;
		isAsciiString: true; 
		contentTypes: Set new.! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:44:06.431'!
isAsciiString
	"Answer the value of isAsciiString"

	^ isAsciiString! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:44:06.447'!
isAsciiString: anObject
	"Set the value of isAsciiString"

	isAsciiString := anObject! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:25:02.225'!
length
	"Answer the value of length"

	^ length! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:25:02.24'!
length: anObject
	"Set the value of length"

	length := anObject! !

!SStringRangeProperties methodsFor: 'contracts' stamp: 'mp 3/21/2012 11:53:51.584'!
printContractFor: anArgumentName with: aBuilder
	| type |
	type := String.
	self printSpellCheckingFor: anArgumentName with: aBuilder.
	self length > 0
		ifTrue: [self printLength: self length 
					for: anArgumentName ofType: type with: aBuilder].
	self isAsciiString
		ifTrue: [self printIs: '#isAsciiString' 
					for: anArgumentName ofType: type with: aBuilder].
	self includesNumbers
		ifFalse: [self printIsNot: '#isAllDigits' 
					for: anArgumentName ofType: type with: aBuilder].	
	self includesSeparators
		ifFalse: [self printIsNot: '#isAllSeparators' 
					for: anArgumentName ofType: type with: aBuilder].					! !

!SStringRangeProperties methodsFor: 'contracts' stamp: 'mp 5/14/2013 15:04:43.273'!
printSpellCheckingFor: anArgumentName with: aBuilder
	self spellingOkay
		ifTrue: [aBuilder printSourceLine: 
				('SContract expectCorrectSpellingOf: ', anArgumentName, '.')].! !

!SStringRangeProperties methodsFor: 'processing' stamp: 'mp 5/2/2012 14:32:08.614'!
process: anObject
	super process: anObject.
	anObject 
		ifNotNil: [self 
					processSpellChecker;
					processStringLength;
					processStringCharacters;
					processStringContentAnalysis].! !

!SStringRangeProperties methodsFor: 'processing' stamp: 'tfel 2/14/2012 15:39:20.807'!
processSpellChecker

	(SpellingInterface new
		setIgnoredWords: #('foo');
		checkSpellingOf: self lastObject startingAt: 1) second = 0
		ifFalse: [self spellingOkay: false].! !

!SStringRangeProperties methodsFor: 'processing' stamp: 'mp 2/8/2012 17:47:16.802'!
processStringCharacters
		self lastObject isAllDigits
			ifTrue: [self includesNumbers: true].
		self lastObject isAsciiString
			ifFalse: [self isAsciiString: false].
		self lastObject isAllSeparators
			ifTrue: [self includesSeparators: true].! !

!SStringRangeProperties methodsFor: 'processing' stamp: 'mp 5/2/2012 14:49:10.165'!
processStringContentAnalysis
	#(asDate asDateAndTime asDuration asInteger asNumber asTime asTimeStamp)
		do: [:each | self check: each].
	[(FileDirectory directoryEntryFor: self lastObject)
		ifNotNil: [self contentTypes add: #fileDirectory]] on: Error do: [nil].
	"to check code is also possible #eval: but it is dangerous and not safe"! !

!SStringRangeProperties methodsFor: 'processing' stamp: 'mp 2/8/2012 17:39:25.195'!
processStringLength
	self length: (self length max: self lastObject size).! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:25:02.195'!
spellingOkay
	"Answer the value of spellingOkay"

	^ spellingOkay! !

!SStringRangeProperties methodsFor: 'accessing' stamp: 'mp 2/8/2012 17:25:02.211'!
spellingOkay: anObject
	"Set the value of spellingOkay"

	spellingOkay := anObject! !

Object subclass: #SHarvester
	instanceVariableNames: 'categories bucket isActive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester'!

!SHarvester class methodsFor: 'pathMap-helper' stamp: 'mp 7/12/2013 12:48:41.112'!
addInfo: aBlock to: aMorph withLabel: aString
	| info |
	info := WriteStream on: String new.
	info
		nextPutAll: aMorph additionalInfo;
		nextPutAll: aString;
		nextPut: Character cr.
	aBlock value: info.
	aMorph additionalInfo: info contents! !

!SHarvester class methodsFor: 'pathMap-helper' stamp: 'mp 2/9/2012 16:14:32.802'!
bucketFrom: aPathMap
	self subclassResponsibility.! !

!SHarvester class methodsFor: 'instance creation' stamp: 'mp 2/3/2012 13:55:55.163'!
createAListOfAllHarvester
	^ SHarvester withAllSubclasses 
		collect: [:each | {each label. #setKindOfAnalysis:. {each}}].! !

!SHarvester class methodsFor: 'instance creation' stamp: 'mp 1/24/2012 16:29:59.198'!
forCategories: categories
	"Create a harvester for the categories given in the passed Collection."
	^ self new categories: categories! !

!SHarvester class methodsFor: 'pathMap-helper' stamp: 'mp 2/9/2012 16:04:13.327'!
getClassMorph: aClass with: aColor from: aPathMap
	| morph |
	morph := aPathMap getClassMorph: aClass.
	morph ifNotNil: [morph propagateColor: aColor].	
	^ morph! !

!SHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 2/2/2012 17:38:03.446'!
getLabelString: aPosition
	^ 'Select a harvester first.'! !

!SHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 2/2/2012 17:35:29.369'!
getLegendColors
	^ {1.0 -> {Color white}}! !

!SHarvester class methodsFor: 'pathMap-helper' stamp: 'mp 2/9/2012 15:59:48.551'!
getMorph: aMethodReference with: aColor from: aPathMap
	| morph |
	morph := aPathMap 
				getMethodMorph: aMethodReference actualClass
				and: aMethodReference methodSymbol.
	morph propagateColor: aColor.	
	^ morph! !

!SHarvester class methodsFor: 'constants' stamp: 'mp 2/3/2012 14:20:47.332'!
identifier
	"Must be unique symbols for storing buckets in projects"
	^ self asString asSymbol! !

!SHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 2/3/2012 13:53:02.639'!
label

	^ 'No Harvester'! !

!SHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 1/31/2012 18:12:20.028'!
visualizeResultsOn: aPathMap
	aPathMap resetAllChildren. 
	"self subclassResponsibility"! !

!SHarvester methodsFor: 'wrapper API' stamp: 'mp 5/7/2013 17:42:11.468'!
arguments: anArrayOfObjects from: aCompiledMethod
	self isActive
		ifTrue: [^ self]
		ifFalse: [self isActive: true.
				anArrayOfObjects withIndexDo: [:each :index | 
				bucket 
					noteArgument: each 
					index: index 
					in: aCompiledMethod].
				self isActive: false].! !

!SHarvester methodsFor: 'accessing' stamp: 'mp 1/24/2012 16:30:07.133'!
bucket
	"Answer the value of bucket"

	^ bucket! !

!SHarvester methodsFor: 'accessing' stamp: 'mp 5/2/2012 17:44:56.786'!
bucket: anObject
	"Set the value of bucket"

	bucket := anObject! !

!SHarvester methodsFor: 'accessing' stamp: 'mp 5/2/2012 17:44:56.773'!
categories
	"Answer the value of categories"

	^ categories! !

!SHarvester methodsFor: 'accessing' stamp: 'mp 1/24/2012 16:30:07.118'!
categories: anObject
	"Set the value of categories"

	categories := anObject! !

!SHarvester methodsFor: 'harvesting-hooks' stamp: 'mp 2/3/2012 14:10:21.731'!
createCollector
	self subclassResponsibility.! !

!SHarvester methodsFor: 'wrapper API' stamp: 'mp 5/2/2012 17:47:07.439'!
instVarsFor: aReceiverObject
	| receiverClass class |
	self isActive
		ifTrue: [^ self]
		ifFalse: [self isActive: true.	
				receiverClass := aReceiverObject class.
				receiverClass allInstVarNames do: [:each | 
					class := receiverClass classThatDefinesInstanceVariable: each.
					bucket
						noteMember: (aReceiverObject instVarNamed: each)
						for: (class instVarIndexFor: each ifAbsent: [])
						in: class].
				self isActive: false].! !

!SHarvester methodsFor: 'accessing' stamp: 'mp 5/2/2012 17:48:50.294'!
isActive
	"Answer the value of isActive"

	^ isActive ifNil: [isActive := false]! !

!SHarvester methodsFor: 'accessing' stamp: 'mp 5/2/2012 17:44:56.878'!
isActive: anObject
	"Set the value of isActive"

	isActive := anObject! !

!SHarvester methodsFor: 'testing' stamp: 'mp 1/24/2012 16:36:57.562'!
isTypeHarvester
	^ false! !

!SHarvester methodsFor: 'testing' stamp: 'mp 2/3/2012 14:29:31.785'!
isValueRangeHarvester
	^ false! !

!SHarvester methodsFor: 'wrapper API' stamp: 'mp 5/2/2012 17:48:13.736'!
return: anObject from: aCompiledMethod
	self isActive
		ifTrue: [^ self]
		ifFalse: [self isActive: true.
				bucket
					noteReturn: anObject
					in: aCompiledMethod.
				self isActive: false].! !

SHarvester subclass: #STypeHarvester
	instanceVariableNames: 'harvestAllTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Harvester'!

!STypeHarvester class methodsFor: 'pathMap-helper' stamp: 'mp 2/9/2012 16:14:20.885'!
bucketFrom: aPathMap
	^ aPathMap project typesBucket! !

!STypeHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 2/2/2012 17:42:34.395'!
getLabelString: aPosition
	^ aPosition y <= 0.5
		ifTrue: ['No types available']
		ifFalse: ['Harvested types']! !

!STypeHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 2/2/2012 17:36:10.513'!
getLegendColors
	^ {	0.5 -> {Color white}. 
		1.0 -> {Color gray}}! !

!STypeHarvester class methodsFor: 'constants' stamp: 'mp 2/6/2012 16:09:14.958'!
label

	^ 'Types'! !

!STypeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 5/7/2013 18:25:58.542'!
visualizeMembersOn: aPathMap
	| members morph | 
	members := (self bucketFrom: aPathMap) members.
	members keysAndValuesDo: [:class :types | 
		morph := self getClassMorph: class with: Color gray from: aPathMap.
		morph ifNotNil: [
			self addInfo: [:stream | 
					types do: [:each | each ifNotNil: [stream 
														nextPutAll: each asString; 
														nextPut: Character cr]]] 
				to: morph 
				withLabel: 'member types']].! !

!STypeHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 1/31/2012 18:06:48.719'!
visualizeResultsOn: aPathMap
	super visualizeResultsOn: aPathMap.
	aPathMap project typesBucket ifNil: [^ self].
	self 
		visualizeTemporariesOn: aPathMap;
		visualizeReturnOn: aPathMap;
		visualizeMembersOn: aPathMap.	! !

!STypeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 7/12/2013 11:06:43.308'!
visualizeReturnOn: aPathMap
	| returns morph | 
	returns := (self bucketFrom: aPathMap) returns.
	returns keysAndValuesDo: [:method :type | 
		morph := self getMorph: method with: Color gray from: aPathMap.
		self addInfo: [:stream | stream 
								nextPutAll: type asString;
								nextPut: Character cr] 
			to: morph 
			withLabel: 'return type'].! !

!STypeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 5/7/2013 18:27:05.524'!
visualizeTemporariesOn: aPathMap
	| temporaries morph | 
	temporaries := (self bucketFrom: aPathMap) arguments.
	temporaries keysAndValuesDo: [:method :types | 
		morph := self getMorph: method with: Color gray from: aPathMap.	
		self addInfo: [:stream | types 
									do: [:each | stream 
													nextPutAll: each asString; 
													nextPut: Character cr]] 
			to: morph 
			withLabel: 'temporary types'].! !

!STypeHarvester methodsFor: 'configuration' stamp: 'mp 4/30/2013 12:01:51.038'!
allTypes
	self harvestAllTypes: true.! !

!STypeHarvester methodsFor: 'initialize-release' stamp: 'mp 5/2/2013 14:12:24.123'!
createCollector
	bucket := self harvestAllTypes
		ifTrue: [ SPolyTypeBucket new ]
		ifFalse: [ SMonoTypeBucket new ]! !

!STypeHarvester methodsFor: 'accessing' stamp: 'mp 4/30/2013 12:01:30.838'!
harvestAllTypes
	"Answer the value of harvestAllTypes"

	^ harvestAllTypes ifNil: [harvestAllTypes := false]! !

!STypeHarvester methodsFor: 'accessing' stamp: 'mp 4/30/2013 11:59:34.278'!
harvestAllTypes: anObject
	"Set the value of harvestAllTypes"

	harvestAllTypes := anObject! !

!STypeHarvester methodsFor: 'testing' stamp: 'mp 1/24/2012 16:37:07.275'!
isTypeHarvester
	^ true! !

SHarvester subclass: #SValueRangeHarvester
	instanceVariableNames: ''
	classVariableNames: 'ColorPropertiesMapping'
	poolDictionaries: ''
	category: 'Path-Harvester'!

!SValueRangeHarvester class methodsFor: 'pathMap-helper' stamp: 'mp 2/9/2012 16:17:54.732'!
bucketFrom: aPathMap
	^ aPathMap project valueRangeBucket! !

!SValueRangeHarvester class methodsFor: 'visualization' stamp: 'mp 2/9/2012 14:28:21.779'!
colorMapping

	^ ColorPropertiesMapping ifNil: [self createColorMapping]! !

!SValueRangeHarvester class methodsFor: 'visualization' stamp: 'mp 2/9/2012 14:47:22.401'!
createColorMapping
	"self createColorMapping"
	| subClasses |
	ColorPropertiesMapping := OrderedCollection new.
	ColorPropertiesMapping add: SDefaultRangeProperties -> {Color lightGray}.
	subClasses := SDefaultRangeProperties allSubclasses.
	subClasses withIndexDo: [:each :index | 
		ColorPropertiesMapping 
			add: each -> {(Color 
							h: 360 * ((index) / subClasses size) 
							s: 0.35 
							v: 1.0)}].
	^ ColorPropertiesMapping! !

!SValueRangeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 5/7/2013 17:44:24.378'!
getHarvestedMethodReferencesFrom: aPathMap
	^ ((self bucketFrom: aPathMap) arguments keys, 
		(self bucketFrom: aPathMap) returns keys)
			asSet asOrderedCollection! !

!SValueRangeHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 2/9/2012 15:02:20.273'!
getLabelString: aPosition
	| numberOfColors distance |
	numberOfColors := self colorMapping size + 1.
	distance := 1 / numberOfColors.
	aPosition y <= distance
		ifTrue: [^ 'No value ranges available'].
	^ (self colorMapping at: (aPosition y / distance) asInteger) key label
! !

!SValueRangeHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 2/9/2012 14:48:30.546'!
getLegendColors
	| numberOfColors colors|
	numberOfColors := self colorMapping size + 1. "+ white color"
	colors := OrderedCollection new.
	colors add: (1 / numberOfColors) -> {Color white}.
	self colorMapping withIndexDo: [:each :index | 
		colors add: (index + 1 / numberOfColors) -> each value].
	^ colors! !

!SValueRangeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 5/7/2013 17:15:22.645'!
getReturnTypesFrom: aMethodReference and: aPathMap
	| types properties |
	types := Set new.
	properties := (self bucketFrom: aPathMap) returns 
		at: aMethodReference 
		ifAbsent: [^ types].
	properties isCollection
		ifTrue: [properties do: [:property | types add: property class]]
		ifFalse: [types add: properties class].
	^ types! !

!SValueRangeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 5/7/2013 17:44:26.694'!
getTemporaryTypesFrom: aMethodReference and: aPathMap
	| types temporaries |
	types := Set new.
	temporaries := (self bucketFrom: aPathMap) arguments 
		at: aMethodReference 
		ifAbsent: [^ types].
	temporaries do: [:each | 
		each isCollection
			ifTrue: [each do: [:property | types add: property class]]
			ifFalse: [types add: each class]].
	^ types! !

!SValueRangeHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 2/9/2012 15:11:23.507'!
label

	^ 'Value Ranges'! !

!SValueRangeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 2/9/2012 16:58:11.374'!
setAdditionalColorsTo: aMorph basedOn: aCollection
	aCollection 
		ifNotEmpty: [
			aMorph additionalColors: (self colorMapping 
				select: [:mapping | aCollection includes: mapping key]
				thenCollect: [:mapping | mapping value first])].! !

!SValueRangeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 5/7/2013 17:44:31.805'!
setAdditionalInfosFrom: aMethodReference to: aMorph on: aPathMap
	aMorph additionalInfo: (Dictionary newFrom: {
		#Method -> aMethodReference stringVersionDefault.
		#Temporaries-> ((self bucketFrom: aPathMap) arguments 
							at: aMethodReference 
							ifAbsent: [nil]). 
		#Return -> ((self bucketFrom: aPathMap) returns 
						at: aMethodReference 
						ifAbsent: [nil])})! !

!SValueRangeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 2/9/2012 17:41:20.955'!
visualizeClassLevelOn: aPathMap
	| members morph | 
	members := (self bucketFrom: aPathMap) members.
	members keysAndValuesDo: [:class :ranges | 
		morph := self getClassMorph: class with: Color black from: aPathMap.
		morph ifNotNil: [morph additionalInfo: ranges]].! !

!SValueRangeHarvester class methodsFor: 'pathMap-visualization' stamp: 'mp 2/9/2012 17:36:35.038'!
visualizeMethodLevelOn: aPathMap
	| morph types |
	(self getHarvestedMethodReferencesFrom: aPathMap) 
		do: [:each | 
			morph := self getMorph: each with: Color black from: aPathMap.
			types := (self getTemporaryTypesFrom: each and: aPathMap), 
						(self getReturnTypesFrom: each and: aPathMap).
			self 
				setAdditionalColorsTo: morph basedOn: types;
				setAdditionalInfosFrom: each to: morph on: aPathMap].! !

!SValueRangeHarvester class methodsFor: 'pathMap-hooks' stamp: 'mp 2/9/2012 14:27:41.359'!
visualizeResultsOn: aPathMap
	super visualizeResultsOn: aPathMap.
	aPathMap project valueRangeBucket ifNil: [^ self].
	self 
		createColorMapping;
		visualizeMethodLevelOn: aPathMap;
		visualizeClassLevelOn: aPathMap.! !

!SValueRangeHarvester methodsFor: 'harvesting-hooks' stamp: 'mp 2/6/2012 16:13:53.804'!
createCollector
	bucket := SValueRangeBucket new.! !

!SValueRangeHarvester methodsFor: 'testing' stamp: 'mp 2/3/2012 14:29:42.918'!
isValueRangeHarvester
	^ true! !

!Interval methodsFor: '*Path-Harvester' stamp: 'mp 2/7/2012 17:32:56.821'!
start
	^ start! !

!Interval methodsFor: '*Path-Harvester' stamp: 'mp 2/7/2012 17:33:00.636'!
stop
	^ stop! !

!Metaclass methodsFor: '*Path-Harvester-override' stamp: 'mha 5/25/2010 09:55'!
category
	"Implicitly assume that metaclasses are contained in the same category as the classes they represent."
	
	^ self soleInstance category! !
